/*******************************************************************************
Gameinfoplus a library to get information from dedicated game servers.

Copyright (C) 2023  Jan Koester jan.koester@tuxist.de

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*******************************************************************************/

#include <mutex>

#include <netplus/socket.h>

#include "gameinfoplus.h"

#pragma once

class HldsView {
public:
    HldsView(const char *addr,int port);
    ~HldsView();

    HldsView(const HldsView &view);

    class HldsData : public GameInfoData{
    public:
        uint8_t     header;
        uint8_t     protocol;
        short       steamid;
        uint8_t     servertype;
        uint8_t     env;
        uint8_t     vac;
        friend class HldsView;
    };

    void refresh(HldsData &info);

private:
    void _parse(HldsData &info,const char *data,size_t len);

    uint8_t       challange[4];

    std::shared_ptr<netplus::udp>  clientSocket;
    std::shared_ptr<netplus::udp>  serverSocket;

    std::mutex rlock;

    int sport;
};
